#! /usr/bin/python

from twisted.spread import pb
from twisted.internet import reactor
from twisted.python import util

from multiprocessing import Process,Queue
import time

class Client(object):
    def __init__(self,host,port,queue):
        self.factory = pb.PBClientFactory()
        reactor.connectTCP(host,port,self.factory)
        self.rootd = self.factory.getRootObject()
        self.dispatcher = None
        self.option = None
        self.portfolio = None
        self.queue = queue

    def got_value(self,value):
        self.queue.put(value) #Putting the value at the end of the queue
        reactor.stop()

    def got_option(self,option):
        self.option = option
        print "got option:", option
        self.option.callRemote("value").addCallback(self.got_value)

    def got_portfolio(self,portfolio):
        self.portfolio = portfolio
        print "got portfolio:", portfolio
        self.portfolio.callRemote(self.compute).addCallback(self.got_value)
         
    def got_dispatcher(self,dispatcher):
        self.dispatcher = dispatcher
        print "got dispatcher:", dispatcher
        print "Asking full portfolio"
        self.dispatcher.callRemote("Portfolio",portfolio).addCallback(
            self.got_portfolio)

    def err_dispatcher(self,reason):
        print "error getting first object", reason
        reactor.stop()

    def activate(self,portfolio,compute):
        self.portfolio = portfolio
        self.compute = compute
        self.rootd.addCallback(self.got_dispatcher)
        self.rootd.addErrback(self.err_dispatcher)
        reactor.run()


def run(client,portfolio,compute):
    client.activate(portfolio,compute)


if __name__ == '__main__':
    q = Queue()
    c = Client("localhost",8800,q)
    portfolio = [("OptionPutAmericanSingle",100.0,100.0,0.1,0.1,0.1,0.3),
                 ("OptionPutAmericanSingle",100.0,100.0,0.1,0.1,0.1,0.4),
                 ("OptionPutAmericanSingle",100.0,100.0,0.1,0.1,0.1,0.5),
                 ("OptionPutAmericanSingle",100.0,100.0,0.1,0.1,0.1,0.6),
                 ("OptionPutAmericanSingle",100.0,100.0,0.1,0.1,0.1,0.7),
                 ("OptionPutAmericanSingle",100.0,100.0,0.1,0.1,0.1,0.8),
                 ("OptionPutAmericanSingle",100.0,100.0,0.1,0.1,0.1,0.9)]
    compute = "value" #value to compute
    p = Process(target = run, args=(c,portfolio,compute))
    p.start()
    p.join()
    print q.get()
